package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseFactionsParams creates a new GetUniverseFactionsParams object
// with the default values initialized.
func NewGetUniverseFactionsParams() *GetUniverseFactionsParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseFactionsParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseFactionsParamsWithTimeout creates a new GetUniverseFactionsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseFactionsParamsWithTimeout(timeout time.Duration) *GetUniverseFactionsParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseFactionsParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetUniverseFactionsParamsWithContext creates a new GetUniverseFactionsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseFactionsParamsWithContext(ctx context.Context) *GetUniverseFactionsParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseFactionsParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

/*GetUniverseFactionsParams contains all the parameters to send to the API endpoint
for the get universe factions operation typically these are written to a http.Request
*/
type GetUniverseFactionsParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Language to use in the response

	*/
	Language *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe factions params
func (o *GetUniverseFactionsParams) WithTimeout(timeout time.Duration) *GetUniverseFactionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe factions params
func (o *GetUniverseFactionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe factions params
func (o *GetUniverseFactionsParams) WithContext(ctx context.Context) *GetUniverseFactionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe factions params
func (o *GetUniverseFactionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the get universe factions params
func (o *GetUniverseFactionsParams) WithDatasource(datasource *string) *GetUniverseFactionsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe factions params
func (o *GetUniverseFactionsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get universe factions params
func (o *GetUniverseFactionsParams) WithLanguage(language *string) *GetUniverseFactionsParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get universe factions params
func (o *GetUniverseFactionsParams) SetLanguage(language *string) {
	o.Language = language
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseFactionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
